/**************************************************************************
		Company     : chiplogic 
		File        : itr_top_glue.v
		Created on  : 17th june 1999
		Created by  : Pramod G
		Modified    : Pramod G on 25th June 1999 
		
		Description : Outing IO_AD ,IO_CBE_N, IO_PAR ,IO_PAR64
		              Getting data from IO_AD & IO_CBE_N
		              Outing O_data_lo,O_data_hi etc
		
		
		
***************************************************************************/
`include "itr_header.v"

module itr_misc 
                   (
                     I_CLK, 
                     I_RST_N,
                     I_DEVSEL_N,
                     I_ACK64_N,//new
                     I_appl_clk, //new
                     I_end_xfer,
                     I_itr_rd_data_avail,
                     I_itr_rd_nxt, 
                     I_itr_wf_full,
                     I_frame_N,
                     I_oe_frame,
                     I_irdy_N,
                     I_oe_irdy,
                     I_oe_AD_hi,
                     I_oe_AD_lo,
                     I_oe_ADDR_lo,
                     I_oe_ADDR_hi,
                     I_incapable64,
                     I_oe_PAR,     // not needed
                     I_oe_PAR64,   // not needed
                     I_incr_itr_rdptr,
                     I_par,
                     I_par64,
                     I_pci_addr_lo, 
                     I_pci_addr_hi, 
                     I_pci_cbe_lo, 
                     I_pci_cbe_hi, 
                     I_latched_data_lo,
                     I_latched_data_hi,
                     I_latched_cbe_lo,
                     I_latched_cbe_hi,
                     I_wr_mode,          // new
                     I_addr_par,         // new
                     I_addr_par64,       // new
                     I_disconnect,       // new

                     IO_AD,
                     IO_CBE_N,
                     IO_PAR,
                     IO_PAR64,
                     IO_FRAME_N,
                     IO_IRDY_N,

                     O_itr_do_wr_xfer,
                     O_data_valid_lo,
                     O_data_valid_hi,
                     O_r_incr_itr_rdptr,
                     O_fifo_rst,
                     O_in_data_lo,
                     O_in_data_hi,
                     O_in_cbe_lo,
                     O_in_cbe_hi,
                     O_disconnect, // new
                     O_64bit_mode  // new
                    
                   );
                   

inout [`DATA_FULL_WIDTH-1:0]         IO_AD;
inout [`CBE_FULL_WIDTH-1:0]          IO_CBE_N;
inout                IO_PAR;
inout                IO_PAR64;
inout                IO_FRAME_N;
inout                IO_IRDY_N;
                   
input                I_CLK; 
input                I_RST_N;
input                I_DEVSEL_N;//new
input                I_ACK64_N;//new
input                I_appl_clk; 
input                I_end_xfer;
input                I_itr_rd_data_avail;
input                I_itr_rd_nxt; 
input                I_itr_wf_full;
input                I_frame_N;
input                I_irdy_N;
input                I_oe_frame;
input                I_oe_irdy;
input                I_oe_AD_hi;
input                I_oe_AD_lo;
input                I_oe_ADDR_lo;
input                I_oe_ADDR_hi;
input                I_incapable64;
input                I_oe_PAR;  // not needed
input                I_oe_PAR64;// not needed
input                I_incr_itr_rdptr;
input                I_par;
input                I_par64;
input [`DATA_HALF_WIDTH-1:0]         I_pci_addr_lo;
input [`DATA_HALF_WIDTH-1:0]         I_pci_addr_hi; 
input [`CBE_HALF_WIDTH-1:0]          I_pci_cbe_lo;
input [`CBE_HALF_WIDTH-1:0]          I_pci_cbe_hi; 
input [`DATA_HALF_WIDTH-1:0]         I_latched_data_lo;
input [`DATA_HALF_WIDTH-1:0]         I_latched_data_hi;
input [`CBE_HALF_WIDTH-1:0]          I_latched_cbe_lo;
input [`CBE_HALF_WIDTH-1:0]          I_latched_cbe_hi;
input                I_wr_mode; 
input                I_addr_par;
input                I_addr_par64;
input                I_disconnect;

output               O_itr_do_wr_xfer;
output               O_data_valid_lo;
output               O_data_valid_hi;
output               O_r_incr_itr_rdptr;
output               O_fifo_rst;
output [`DATA_HALF_WIDTH-1:0]        O_in_data_lo;
output [`DATA_HALF_WIDTH-1:0]        O_in_data_hi;
output [`CBE_HALF_WIDTH-1:0]         O_in_cbe_lo;
output [`CBE_HALF_WIDTH-1:0]         O_in_cbe_hi;
output               O_disconnect;
output               O_64bit_mode;

reg                  O_fifo_rst;
reg                  O_r_incr_itr_rdptr;
reg                  O_data_valid_lo;
reg                  O_data_valid_hi;
reg                  O_disconnect;
reg                  O_64bit_mode;

reg                  r_frame_N;
reg                  r_irdy_N;  
reg                  r_oe_frame;
reg                  r_oe_irdy;
reg                  r_oe_AD_hi;
reg                  r_oe_AD_lo;
reg                  r_oe_ADDR_lo;
reg                  r_oe_ADDR_hi;
reg                  r_incapable64;
reg                  sig_2;
reg                  xfer_64_flag;
reg                  oe_par_addr;
reg                  oe_par_addr64;
reg                  oe_par_data;
reg                  oe_par_data64;
reg                  PAR;
reg                  PAR64;

wire                 oe_IO_AD_lo;
wire                 oe_IO_AD_hi;
wire [`DATA_HALF_WIDTH-1:0]          addr_lo;  
wire [`DATA_HALF_WIDTH-1:0]          addr_hi;  
wire [`DATA_HALF_WIDTH-1:0]          data_lo;  
wire [`DATA_HALF_WIDTH-1:0]          data_hi;
wire [`CBE_HALF_WIDTH-1:0]           comm_lo;  
wire [`CBE_HALF_WIDTH-1:0]           comm_hi;  
wire [`CBE_HALF_WIDTH-1:0]           byte_enb_lo;  
wire [`CBE_HALF_WIDTH-1:0]           byte_enb_hi;  
wire [`DATA_HALF_WIDTH-1:0]          data_1;
wire [`DATA_HALF_WIDTH-1:0]          addr_1;

assign oe_IO_AD_lo = r_oe_AD_lo | r_oe_ADDR_lo;
assign oe_IO_AD_hi = r_oe_AD_hi | r_oe_ADDR_hi | r_oe_ADDR_lo;

assign O_itr_do_wr_xfer = I_wr_mode & (~I_itr_wf_full) ;      

assign O_in_data_lo = IO_AD[31:0];
assign O_in_data_hi = IO_AD[63:32];

assign addr_1  = (r_oe_ADDR_hi) ? I_pci_addr_hi : I_pci_addr_lo;
assign addr_lo = (r_oe_ADDR_lo) ? addr_1 : 32'b0;
assign addr_hi = (r_oe_ADDR_lo) ? I_pci_addr_hi : 32'b0;

assign data_1  = (r_incapable64) ? I_latched_data_hi : I_latched_data_lo;
assign data_lo = (r_oe_AD_lo) ? data_1 : 32'b0;
assign data_hi = (r_oe_AD_hi) ? I_latched_data_hi : 32'b0;

assign IO_AD[31:0]  = (oe_IO_AD_lo) ? (addr_lo | data_lo) : 32'bz;
assign IO_AD[63:32] = (oe_IO_AD_hi) ? (addr_hi | data_hi) : 32'bz;

assign O_in_cbe_lo = {~IO_CBE_N[3], ~IO_CBE_N[2], ~IO_CBE_N[1], ~IO_CBE_N[0]}; // just invert each bit        
assign O_in_cbe_hi = {~IO_CBE_N[7], ~IO_CBE_N[6], ~IO_CBE_N[5], ~IO_CBE_N[4]}; // just invert each bit        

assign comm_lo[0] = (r_oe_ADDR_lo) & (~I_pci_cbe_lo[0]);
assign comm_lo[1] = (r_oe_ADDR_lo) & (~I_pci_cbe_lo[1]);
assign comm_lo[2] = (r_oe_ADDR_lo) & (~I_pci_cbe_lo[2]);
assign comm_lo[3] = (r_oe_ADDR_lo) & (~I_pci_cbe_lo[3]);

assign byte_enb_lo[0] = (r_oe_AD_lo)  & (~I_pci_cbe_lo[0]);
assign byte_enb_lo[1] = (r_oe_AD_lo)  & (~I_pci_cbe_lo[1]);
assign byte_enb_lo[2] = (r_oe_AD_lo)  & (~I_pci_cbe_lo[2]);
assign byte_enb_lo[3] = (r_oe_AD_lo)  & (~I_pci_cbe_lo[3]);

assign IO_CBE_N[3:0] = (oe_IO_AD_lo) ? (comm_lo | byte_enb_lo) : 4'bz;

assign byte_enb_hi = {~I_pci_cbe_hi[0],~I_pci_cbe_hi[1],
                      ~I_pci_cbe_hi[2],~I_pci_cbe_hi[3]};
                      
assign IO_CBE_N[7:4] = (r_oe_AD_lo) ? (byte_enb_hi) : 4'bz;


assign IO_FRAME_N = (r_oe_frame) ? r_frame_N : 1'bz ;
assign IO_IRDY_N  = (r_oe_irdy)  ? r_irdy_N  : 1'bz ;

assign IO_PAR   = PAR; 
assign IO_PAR64 = PAR64; 

always @(oe_par_addr  or oe_par_addr64 or oe_par_data or oe_par_data64
         or I_addr_par or I_addr_par64  or I_par      or I_par64 )
   if(oe_par_addr)
      begin
      PAR   <= I_addr_par;
      PAR64 <= 1'bz;
      end
   else if(oe_par_addr64)
      begin
      PAR   <= 1'bz;
      PAR64 <= I_addr_par64 ;
      end
   else if(oe_par_data)
      begin
      PAR   <= I_par;
      PAR64 <= 1'bz ;
      end
   else if(oe_par_data64)
      begin
      PAR   <= 1'bz;
      PAR64 <=I_par64 ;
      end
   else   
      begin
      PAR   <= 1'bz;
      PAR64 <= 1'bz;
      end


// Generate a fifo reset pulse aligned to appl_clk ( for iwf)
// looks like the asynchronous set is unavoidable 

always@(negedge I_RST_N or posedge I_end_xfer or posedge I_appl_clk) 

begin
if (!I_RST_N)
   O_fifo_rst <= 1'b0 ;
else 
   O_fifo_rst <= I_end_xfer ; // asynchronouse set 
end 


// register 

always@(negedge I_RST_N or posedge I_CLK)
begin

if (!I_RST_N)
   begin                          // check
      r_frame_N     <= 1'b1;
      r_irdy_N      <= 1'b1;
      r_oe_frame    <= 1'b1;
      r_oe_irdy     <= 1'b1;
      r_oe_AD_hi    <= 1'b1;
      r_oe_AD_lo    <= 1'b1;
      r_oe_ADDR_lo  <= 1'b1;
      r_oe_ADDR_hi  <= 1'b1;
      r_incapable64 <= 1'b1;
   end
else
   begin
      r_frame_N     <= I_frame_N;
      r_irdy_N      <= I_irdy_N;
      r_oe_frame    <= I_oe_frame;
      r_oe_irdy     <= I_oe_irdy;
      r_oe_AD_hi    <= I_oe_AD_hi;
      r_oe_AD_lo    <= I_oe_AD_lo;
      r_oe_ADDR_lo  <= I_oe_ADDR_lo;
      r_oe_ADDR_hi  <= I_oe_ADDR_hi;
      r_incapable64 <= I_incapable64; 
   end
end
// - 2 cycles delay for reads to be provided for balancing 
always@(posedge I_CLK or negedge I_RST_N)
begin

if (!I_RST_N)
   begin
      sig_2 <= 1'b0 ;
      O_r_incr_itr_rdptr <= 1'b0 ;
   end 
else
   begin
      sig_2 <= I_incr_itr_rdptr ;
      O_r_incr_itr_rdptr <= sig_2 ;
   end 
end 

// checking whether read data(from pci side) is 64 bit
always@(posedge I_CLK or negedge I_RST_N)
begin 
if (!I_RST_N) 
   xfer_64_flag <= 1'b0 ;
else
   if (!I_DEVSEL_N && !I_ACK64_N) 
      xfer_64_flag <= 1'b1 ; // set condition
   else if (!I_DEVSEL_N && I_ACK64_N)
      xfer_64_flag <= 1'b0 ; // at the next non 64 command 
end 


// generate the data valid signals 

always@(posedge I_appl_clk or negedge I_RST_N or negedge I_itr_rd_data_avail)
begin
if (!I_RST_N) 
   begin
      O_data_valid_lo <= 1'b0 ; // worry about hi later
      O_data_valid_hi <= 1'b0 ;
   end 
else if (!I_itr_rd_data_avail)
   begin
      O_data_valid_lo <= 1'b0 ;
      O_data_valid_hi <= 1'b0 ;
   end 
else
   begin
      if (I_itr_rd_nxt)
         begin 
           
            O_data_valid_lo <= 1'b1 ;
             O_data_valid_hi <= xfer_64_flag;
         end 
      else
         begin
            O_data_valid_lo <= 1'b0 ;
            O_data_valid_hi <= 1'b0 ;
         end 
   end 
end

// Generate enables for parity out 
always@(posedge I_CLK or negedge I_RST_N)
begin
if (!I_RST_N)
   begin
      oe_par_addr   <= 1'b0 ;
      oe_par_addr64 <= 1'b0 ;
      oe_par_data   <= 1'b0 ;
      oe_par_data64 <= 1'b0 ;
   end 
else
   begin
      oe_par_data   <= r_oe_AD_lo;
      oe_par_data64 <= r_oe_AD_hi;
      oe_par_addr   <= r_oe_ADDR_lo;
      oe_par_addr64 <= r_oe_ADDR_hi;
   end
end 

// out O_disconnect
always@(posedge I_appl_clk or negedge I_RST_N )
begin
   if (!I_RST_N) 
      O_disconnect <= 1'b0;
   else
      O_disconnect <= I_disconnect;
end   
        
// out O_64bit_mode
always@(posedge I_appl_clk or negedge I_RST_N )
begin
   if (!I_RST_N) 
      O_64bit_mode <= 1'b0;
   else
      O_64bit_mode <= ~I_ACK64_N;
//changed I_ACK64_N to ~I_ACK64_N
end   

endmodule

                  